Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1200)
@@ -1,8 +1,8 @@
-﻿/* The copyright in this software is being made available under the BSD
+/* The copyright in this software is being made available under the BSD
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -45,9 +45,6 @@
 #include "TComRom.h"
 #include "TComList.h"
-#if H_MV
-#include <ios>
-#include <iostream>
-#include <iomanip>
-#endif
+#include "TComChromaFormat.h"
+
 //! \ingroup TLibCommon
 //! \{
@@ -55,5 +52,5 @@
 class TComPic;
 class TComTrQuant;
-#if H_MV
+#if NH_MV
 class TComPicLists; 
 class TComVPS; 
@@ -63,4 +60,6 @@
 // Constants
 // ====================================================================================================================
+
+static const UInt REF_PIC_LIST_NUM_IDX=32;
 
 // ====================================================================================================================
@@ -80,7 +79,7 @@
   Bool m_used[MAX_NUM_REF_PICS];
   Bool m_interRPSPrediction;
-  Int  m_deltaRIdxMinus1;   
-  Int  m_deltaRPS; 
-  Int  m_numRefIdc; 
+  Int  m_deltaRIdxMinus1;
+  Int  m_deltaRPS;
+  Int  m_numRefIdc;
   Int  m_refIdc[MAX_NUM_REF_PICS+1];
   Bool m_bCheckLTMSB[MAX_NUM_REF_PICS];
@@ -90,49 +89,50 @@
 
 public:
-  TComReferencePictureSet();
+          TComReferencePictureSet();
   virtual ~TComReferencePictureSet();
-  Int   getPocLSBLT(Int i)                       { return m_pocLSBLT[i]; }
-  Void  setPocLSBLT(Int i, Int x)                { m_pocLSBLT[i] = x; }
-  Int   getDeltaPocMSBCycleLT(Int i)             { return m_deltaPOCMSBCycleLT[i]; }
-  Void  setDeltaPocMSBCycleLT(Int i, Int x)      { m_deltaPOCMSBCycleLT[i] = x; }
-  Bool  getDeltaPocMSBPresentFlag(Int i)         { return m_deltaPocMSBPresentFlag[i]; }
-  Void  setDeltaPocMSBPresentFlag(Int i, Bool x) { m_deltaPocMSBPresentFlag[i] = x;    }
-  Void setUsed(Int bufferNum, Bool used);
-  Void setDeltaPOC(Int bufferNum, Int deltaPOC);
-  Void setPOC(Int bufferNum, Int deltaPOC);
-  Void setNumberOfPictures(Int numberOfPictures);
-  Void setCheckLTMSBPresent(Int bufferNum, Bool b );
-  Bool getCheckLTMSBPresent(Int bufferNum);
-
-  Int  getUsed(Int bufferNum);
-  Int  getDeltaPOC(Int bufferNum);
-  Int  getPOC(Int bufferNum);
-  Int  getNumberOfPictures();
-
-  Void setNumberOfNegativePictures(Int number)  { m_numberOfNegativePictures = number; }
-  Int  getNumberOfNegativePictures()            { return m_numberOfNegativePictures; }
-  Void setNumberOfPositivePictures(Int number)  { m_numberOfPositivePictures = number; }
-  Int  getNumberOfPositivePictures()            { return m_numberOfPositivePictures; }
-  Void setNumberOfLongtermPictures(Int number)  { m_numberOfLongtermPictures = number; }
-  Int  getNumberOfLongtermPictures()            { return m_numberOfLongtermPictures; }
-
-  Void setInterRPSPrediction(Bool flag)         { m_interRPSPrediction = flag; }
-  Bool getInterRPSPrediction()                  { return m_interRPSPrediction; }
-  Void setDeltaRIdxMinus1(Int x)                { m_deltaRIdxMinus1 = x; }
-  Int  getDeltaRIdxMinus1()                     { return m_deltaRIdxMinus1; }
-  Void setDeltaRPS(Int x)                       { m_deltaRPS = x; }
-  Int  getDeltaRPS()                            { return m_deltaRPS; }
-  Void setNumRefIdc(Int x)                      { m_numRefIdc = x; }
-  Int  getNumRefIdc()                           { return m_numRefIdc; }
-
-  Void setRefIdc(Int bufferNum, Int refIdc);
-  Int  getRefIdc(Int bufferNum);
-
-  Void sortDeltaPOC();
-  Void printDeltaPOC();
-
-#if H_MV
-  Void checkMaxNumPics( Bool vpsExtensionFlag, Int maxNumPics, Int nuhLayerId, Int spsMaxDecPicBufferingMinus1 );
-#endif
+  Int     getPocLSBLT(Int i) const                     { return m_pocLSBLT[i];               }
+  Void    setPocLSBLT(Int i, Int x)                    { m_pocLSBLT[i] = x;                  }
+  Int     getDeltaPocMSBCycleLT(Int i) const           { return m_deltaPOCMSBCycleLT[i];     }
+  Void    setDeltaPocMSBCycleLT(Int i, Int x)          { m_deltaPOCMSBCycleLT[i] = x;        }
+  Bool    getDeltaPocMSBPresentFlag(Int i) const       { return m_deltaPocMSBPresentFlag[i]; }
+  Void    setDeltaPocMSBPresentFlag(Int i, Bool x)     { m_deltaPocMSBPresentFlag[i] = x;    }
+  Void    setUsed(Int bufferNum, Bool used);
+  Void    setDeltaPOC(Int bufferNum, Int deltaPOC);
+  Void    setPOC(Int bufferNum, Int deltaPOC);
+  Void    setNumberOfPictures(Int numberOfPictures);
+  Void    setCheckLTMSBPresent(Int bufferNum, Bool b );
+  Bool    getCheckLTMSBPresent(Int bufferNum) const;
+
+  Int     getUsed(Int bufferNum) const;
+  Int     getDeltaPOC(Int bufferNum) const;
+  Int     getPOC(Int bufferNum) const;
+  Int     getNumberOfPictures() const;
+
+  Void    setNumberOfNegativePictures(Int number)      { m_numberOfNegativePictures = number; }
+  Int     getNumberOfNegativePictures() const          { return m_numberOfNegativePictures;   }
+  Void    setNumberOfPositivePictures(Int number)      { m_numberOfPositivePictures = number; }
+  Int     getNumberOfPositivePictures() const          { return m_numberOfPositivePictures;   }
+  Void    setNumberOfLongtermPictures(Int number)      { m_numberOfLongtermPictures = number; }
+  Int     getNumberOfLongtermPictures() const          { return m_numberOfLongtermPictures;   }
+
+  Void    setInterRPSPrediction(Bool flag)             { m_interRPSPrediction = flag;         }
+  Bool    getInterRPSPrediction() const                { return m_interRPSPrediction;         }
+  Void    setDeltaRIdxMinus1(Int x)                    { m_deltaRIdxMinus1 = x;               }
+  Int     getDeltaRIdxMinus1() const                   { return m_deltaRIdxMinus1;            }
+  Void    setDeltaRPS(Int x)                           { m_deltaRPS = x;                      }
+  Int     getDeltaRPS() const                          { return m_deltaRPS;                   }
+  Void    setNumRefIdc(Int x)                          { m_numRefIdc = x;                     }
+  Int     getNumRefIdc() const                         { return m_numRefIdc;                  }
+
+  Void    setRefIdc(Int bufferNum, Int refIdc);
+  Int     getRefIdc(Int bufferNum) const ;
+
+  Void    sortDeltaPOC();
+  Void    printDeltaPOC() const;
+
+#if NH_MV
+  Void checkMaxNumPics( Bool vpsExtensionFlag, Int maxNumPics, Int nuhLayerId, Int spsMaxDecPicBufferingMinus1 ) const;
+#endif
+
 };
 
@@ -141,18 +141,18 @@
 {
 private:
-  Int  m_numberOfReferencePictureSets;
-  TComReferencePictureSet* m_referencePictureSets;
-  
+  std::vector<TComReferencePictureSet> m_referencePictureSets;
+
 public:
-  TComRPSList();
-  virtual ~TComRPSList();
-  
-  Void  create  (Int numberOfEntries);
-  Void  destroy ();
-
-
-  TComReferencePictureSet* getReferencePictureSet(Int referencePictureSetNum);
-  Int getNumberOfReferencePictureSets();
-  Void setNumberOfReferencePictureSets(Int numberOfReferencePictureSets);
+                                 TComRPSList()                                            { }
+  virtual                        ~TComRPSList()                                           { }
+
+  Void                           create  (Int numberOfEntries)                            { m_referencePictureSets.resize(numberOfEntries);         }
+  Void                           destroy ()                                               { }
+
+
+  TComReferencePictureSet*       getReferencePictureSet(Int referencePictureSetNum)       { return &m_referencePictureSets[referencePictureSetNum]; }
+  const TComReferencePictureSet* getReferencePictureSet(Int referencePictureSetNum) const { return &m_referencePictureSets[referencePictureSetNum]; }
+
+  Int                            getNumberOfReferencePictureSets() const                  { return Int(m_referencePictureSets.size());              }
 };
 
@@ -161,124 +161,139 @@
 {
 public:
-  TComScalingList();
-  virtual ~TComScalingList();
-  Void     setScalingListPresentFlag    (Bool b)                               { m_scalingListPresentFlag = b;    }
-  Bool     getScalingListPresentFlag    ()                                     { return m_scalingListPresentFlag; }
-  Int*     getScalingListAddress          (UInt sizeId, UInt listId)           { return m_scalingListCoef[sizeId][listId]; } //!< get matrix coefficient
-  Bool     checkPredMode                  (UInt sizeId, UInt listId);
-  Void     setRefMatrixId                 (UInt sizeId, UInt listId, UInt u)   { m_refMatrixId[sizeId][listId] = u;    }     //!< set reference matrix ID
-  UInt     getRefMatrixId                 (UInt sizeId, UInt listId)           { return m_refMatrixId[sizeId][listId]; }     //!< get reference matrix ID
-  Int*     getScalingListDefaultAddress   (UInt sizeId, UInt listId);                                                        //!< get default matrix coefficient
-  Void     processDefaultMatrix            (UInt sizeId, UInt listId);
-  Void     setScalingListDC               (UInt sizeId, UInt listId, UInt u)   { m_scalingListDC[sizeId][listId] = u; }      //!< set DC value
-
-  Int      getScalingListDC               (UInt sizeId, UInt listId)           { return m_scalingListDC[sizeId][listId]; }   //!< get DC value
-  Void     checkDcOfMatrix                ();
-  Void     processRefMatrix               (UInt sizeId, UInt listId , UInt refListId );
-  Bool     xParseScalingList              (Char* pchFile);
-#if H_MV
-  Void     inferFrom                      ( TComScalingList* srcScLi );
-#endif
+             TComScalingList();
+  virtual    ~TComScalingList()                                                 { }
+  Int*       getScalingListAddress(UInt sizeId, UInt listId)                    { return &(m_scalingListCoef[sizeId][listId][0]);            } //!< get matrix coefficient
+  const Int* getScalingListAddress(UInt sizeId, UInt listId) const              { return &(m_scalingListCoef[sizeId][listId][0]);            } //!< get matrix coefficient
+  Void       checkPredMode(UInt sizeId, UInt listId);
+
+  Void       setRefMatrixId(UInt sizeId, UInt listId, UInt u)                   { m_refMatrixId[sizeId][listId] = u;                         } //!< set reference matrix ID
+  UInt       getRefMatrixId(UInt sizeId, UInt listId) const                     { return m_refMatrixId[sizeId][listId];                      } //!< get reference matrix ID
+
+  const Int* getScalingListDefaultAddress(UInt sizeId, UInt listId);                                                                           //!< get default matrix coefficient
+  Void       processDefaultMatrix(UInt sizeId, UInt listId);
+
+  Void       setScalingListDC(UInt sizeId, UInt listId, UInt u)                 { m_scalingListDC[sizeId][listId] = u;                       } //!< set DC value
+  Int        getScalingListDC(UInt sizeId, UInt listId) const                   { return m_scalingListDC[sizeId][listId];                    } //!< get DC value
+
+  Void       setScalingListPredModeFlag(UInt sizeId, UInt listId, Bool bIsDPCM) { m_scalingListPredModeFlagIsDPCM[sizeId][listId] = bIsDPCM; }
+  Bool       getScalingListPredModeFlag(UInt sizeId, UInt listId) const         { return m_scalingListPredModeFlagIsDPCM[sizeId][listId];    }
+
+  Void       checkDcOfMatrix();
+  Void       processRefMatrix(UInt sizeId, UInt listId , UInt refListId );
+  Bool       xParseScalingList(Char* pchFile);
+#if NH_MV
+  Void       inferFrom                      ( const TComScalingList& srcScLi );
+#endif
+  Void       setDefaultScalingList();
+  Bool       checkDefaultScalingList();
 
 private:
-  Void     init                    ();
-  Void     destroy                 ();
-  Int      m_scalingListDC               [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< the DC value of the matrix coefficient for 16x16
-  Bool     m_useDefaultScalingMatrixFlag [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< UseDefaultScalingMatrixFlag
-  UInt     m_refMatrixId                 [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< RefMatrixID
-  Bool     m_scalingListPresentFlag;                                                //!< flag for using default matrix
-  UInt     m_predMatrixId                [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< reference list index
-  Int      *m_scalingListCoef            [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< quantization matrix
+  Void       outputScalingLists(std::ostream &os) const;
+  Bool             m_scalingListPredModeFlagIsDPCM [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< reference list index
+  Int              m_scalingListDC                 [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< the DC value of the matrix coefficient for 16x16
+  UInt             m_refMatrixId                   [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< RefMatrixID
+  std::vector<Int> m_scalingListCoef               [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< quantization matrix
 };
 
 class ProfileTierLevel
 {
-  Int     m_profileSpace;
-  Bool    m_tierFlag;
-  Int     m_profileIdc;
-  Bool    m_profileCompatibilityFlag[32];
-  Int     m_levelIdc;
-
-  Bool m_progressiveSourceFlag;
-  Bool m_interlacedSourceFlag;
-  Bool m_nonPackedConstraintFlag;
-  Bool m_frameOnlyConstraintFlag;
-  
-#if H_MV
-  Bool m_max12bitConstraintFlag;
-  Bool m_max10bitConstraintFlag;
-  Bool m_max8bitConstraintFlag;
-  Bool m_max422chromaConstraintFlag;
-  Bool m_max420chromaConstraintFlag;
-  Bool m_maxMonochromeConstraintFlag;
-  Bool m_intraConstraintFlag;
-  Bool m_onePictureOnlyConstraintFlag;
-  Bool m_lowerBitRateConstraintFlag;
-  Bool m_inbldFlag;
+  Int               m_profileSpace;
+  Level::Tier       m_tierFlag;
+  Profile::Name     m_profileIdc;
+  Bool              m_profileCompatibilityFlag[32];
+  Level::Name       m_levelIdc;
+
+  Bool              m_progressiveSourceFlag;
+  Bool              m_interlacedSourceFlag;
+  Bool              m_nonPackedConstraintFlag;
+  Bool              m_frameOnlyConstraintFlag;
+  UInt              m_bitDepthConstraintValue;
+  ChromaFormat      m_chromaFormatConstraintValue;
+  Bool              m_intraConstraintFlag;
+  Bool              m_onePictureOnlyConstraintFlag;
+  Bool              m_lowerBitRateConstraintFlag;
+#if NH_MV
+  Bool              m_max12bitConstraintFlag;
+  Bool              m_max10bitConstraintFlag;
+  Bool              m_max8bitConstraintFlag;
+  Bool              m_max422chromaConstraintFlag;
+  Bool              m_max420chromaConstraintFlag;
+  Bool              m_maxMonochromeConstraintFlag;
+  Bool              m_inbldFlag;
 #endif
 public:
-  ProfileTierLevel();
-
-  Int   getProfileSpace() const   { return m_profileSpace; }
-  Void  setProfileSpace(Int x)    { m_profileSpace = x; }
-
-  Bool  getTierFlag()     const   { return m_tierFlag; }
-  Void  setTierFlag(Bool x)       { m_tierFlag = x; }
-
-  Int   getProfileIdc()   const   { return m_profileIdc; }
-  Void  setProfileIdc(Int x)      { m_profileIdc = x; }
-
-  Bool  getProfileCompatibilityFlag(Int i) const    { return m_profileCompatibilityFlag[i]; }
-  Void  setProfileCompatibilityFlag(Int i, Bool x)  { m_profileCompatibilityFlag[i] = x; }
-
-  Int   getLevelIdc()   const   { return m_levelIdc; }
-  Void  setLevelIdc(Int x)      { m_levelIdc = x; }
-  
-  Bool getProgressiveSourceFlag() const { return m_progressiveSourceFlag; }
-  Void setProgressiveSourceFlag(Bool b) { m_progressiveSourceFlag = b; }
-  
-  Bool getInterlacedSourceFlag() const { return m_interlacedSourceFlag; }
-  Void setInterlacedSourceFlag(Bool b) { m_interlacedSourceFlag = b; }
-  
-  Bool getNonPackedConstraintFlag() const { return m_nonPackedConstraintFlag; }
-  Void setNonPackedConstraintFlag(Bool b) { m_nonPackedConstraintFlag = b; }
-  
-  Bool getFrameOnlyConstraintFlag() const { return m_frameOnlyConstraintFlag; }
-  Void setFrameOnlyConstraintFlag(Bool b) { m_frameOnlyConstraintFlag = b; }
-
-#if H_MV
-  Void setMax12bitConstraintFlag( Bool flag ) { m_max12bitConstraintFlag = flag; } 
-  Bool getMax12bitConstraintFlag(  ) { return m_max12bitConstraintFlag; } 
-  
-  Void setMax10bitConstraintFlag( Bool flag ) { m_max10bitConstraintFlag = flag; } 
-  Bool getMax10bitConstraintFlag(  ) { return m_max10bitConstraintFlag; } 
-  
-  Void setMax8bitConstraintFlag( Bool flag ) { m_max8bitConstraintFlag = flag; } 
-  Bool getMax8bitConstraintFlag(  ) { return m_max8bitConstraintFlag; } 
-  
-  Void setMax422chromaConstraintFlag( Bool flag ) { m_max422chromaConstraintFlag = flag; } 
-  Bool getMax422chromaConstraintFlag(  ) { return m_max422chromaConstraintFlag; } 
-  
-  Void setMax420chromaConstraintFlag( Bool flag ) { m_max420chromaConstraintFlag = flag; } 
-  Bool getMax420chromaConstraintFlag(  ) { return m_max420chromaConstraintFlag; } 
-  
-  Void setMaxMonochromeConstraintFlag( Bool flag ) { m_maxMonochromeConstraintFlag = flag; } 
-  Bool getMaxMonochromeConstraintFlag(  ) { return m_maxMonochromeConstraintFlag; } 
-  Void setIntraConstraintFlag( Bool flag ) { m_intraConstraintFlag = flag; } 
-  Bool getIntraConstraintFlag(  ) { return m_intraConstraintFlag; } 
-  
-  Void setOnePictureOnlyConstraintFlag( Bool flag ) { m_onePictureOnlyConstraintFlag = flag; } 
-  Bool getOnePictureOnlyConstraintFlag(  ) { return m_onePictureOnlyConstraintFlag; } 
-  
-  Void setLowerBitRateConstraintFlag( Bool flag ) { m_lowerBitRateConstraintFlag = flag; } 
-  Bool getLowerBitRateConstraintFlag(  ) { return m_lowerBitRateConstraintFlag; } 
-  
-  Void setInbldFlag( Bool flag ) { m_inbldFlag = flag; } 
-  Bool getInbldFlag(  ) { return m_inbldFlag; } 
-  Bool getV2ConstraintsPresentFlag();  
-  Bool getInbldPresentFlag();
-  Void copyV2ConstraintFlags( ProfileTierLevel* ptlRef );
-  Void copyProfile( ProfileTierLevel* ptlRef );
-#endif
+                ProfileTierLevel();
+
+  Int           getProfileSpace() const                     { return m_profileSpace;                }
+  Void          setProfileSpace(Int x)                      { m_profileSpace = x;                   }
+
+  Level::Tier   getTierFlag() const                         { return m_tierFlag;                    }
+  Void          setTierFlag(Level::Tier x)                  { m_tierFlag = x;                       }
+
+  Profile::Name getProfileIdc() const                       { return m_profileIdc;                  }
+  Void          setProfileIdc(Profile::Name x)              { m_profileIdc = x;                     }
+
+  Bool          getProfileCompatibilityFlag(Int i) const    { return m_profileCompatibilityFlag[i]; }
+  Void          setProfileCompatibilityFlag(Int i, Bool x)  { m_profileCompatibilityFlag[i] = x;    }
+
+  Level::Name   getLevelIdc() const                         { return m_levelIdc;                    }
+  Void          setLevelIdc(Level::Name x)                  { m_levelIdc = x;                       }
+
+  Bool          getProgressiveSourceFlag() const            { return m_progressiveSourceFlag;       }
+  Void          setProgressiveSourceFlag(Bool b)            { m_progressiveSourceFlag = b;          }
+
+  Bool          getInterlacedSourceFlag() const             { return m_interlacedSourceFlag;        }
+  Void          setInterlacedSourceFlag(Bool b)             { m_interlacedSourceFlag = b;           }
+
+  Bool          getNonPackedConstraintFlag() const          { return m_nonPackedConstraintFlag;     }
+  Void          setNonPackedConstraintFlag(Bool b)          { m_nonPackedConstraintFlag = b;        }
+
+  Bool          getFrameOnlyConstraintFlag() const          { return m_frameOnlyConstraintFlag;     }
+  Void          setFrameOnlyConstraintFlag(Bool b)          { m_frameOnlyConstraintFlag = b;        }
+
+  UInt          getBitDepthConstraint() const               { return m_bitDepthConstraintValue;     }
+  Void          setBitDepthConstraint(UInt bitDepth)        { m_bitDepthConstraintValue=bitDepth;   }
+
+  ChromaFormat  getChromaFormatConstraint() const           { return m_chromaFormatConstraintValue; }
+  Void          setChromaFormatConstraint(ChromaFormat fmt) { m_chromaFormatConstraintValue=fmt;    }
+
+  Bool          getIntraConstraintFlag() const              { return m_intraConstraintFlag;         }
+  Void          setIntraConstraintFlag(Bool b)              { m_intraConstraintFlag = b;            }
+
+  Bool          getOnePictureOnlyConstraintFlag() const     { return m_onePictureOnlyConstraintFlag;}
+  Void          setOnePictureOnlyConstraintFlag(Bool b)     { m_onePictureOnlyConstraintFlag = b;   }
+
+  Bool          getLowerBitRateConstraintFlag() const       { return m_lowerBitRateConstraintFlag;  }
+  Void          setLowerBitRateConstraintFlag(Bool b)       { m_lowerBitRateConstraintFlag = b;     }
+
+#if NH_MV
+  Void          setMax12bitConstraintFlag( Bool flag )      { m_max12bitConstraintFlag = flag;      }
+  Bool          getMax12bitConstraintFlag(  ) const         { return m_max12bitConstraintFlag;      }
+
+  Void          setMax10bitConstraintFlag( Bool flag )      { m_max10bitConstraintFlag = flag;      }
+  Bool          getMax10bitConstraintFlag(  ) const         { return m_max10bitConstraintFlag;      }
+
+  Void          setMax8bitConstraintFlag( Bool flag )       { m_max8bitConstraintFlag = flag;       }
+  Bool          getMax8bitConstraintFlag(  ) const          { return m_max8bitConstraintFlag;       }
+
+  Void          setMax422chromaConstraintFlag( Bool flag )  { m_max422chromaConstraintFlag = flag;  }
+  Bool          getMax422chromaConstraintFlag(  ) const     { return m_max422chromaConstraintFlag;  }
+
+  Void          setMax420chromaConstraintFlag( Bool flag )  { m_max420chromaConstraintFlag = flag;  }
+  Bool          getMax420chromaConstraintFlag(  ) const     { return m_max420chromaConstraintFlag;  }
+
+  Void          setMaxMonochromeConstraintFlag( Bool flag ) { m_maxMonochromeConstraintFlag = flag; }
+  Bool          getMaxMonochromeConstraintFlag(  ) const    { return m_maxMonochromeConstraintFlag; }
+
+  Void          setInbldFlag( Bool flag )                   { m_inbldFlag = flag;                   }
+  Bool          getInbldFlag(  ) const                      { return m_inbldFlag;                   }
+
+  Bool          getV2ConstraintsPresentFlag() const;
+  Bool          getInbldPresentFlag() const;
+
+  Void          copyV2ConstraintFlags( ProfileTierLevel* ptlRef );
+  Void          copyProfile( ProfileTierLevel* ptlRef );
+#endif
+
 };
 
@@ -292,18 +307,23 @@
 
 public:
-  TComPTL();
-  Bool getSubLayerProfilePresentFlag(Int i) const { return m_subLayerProfilePresentFlag[i]; }
-  Void setSubLayerProfilePresentFlag(Int i, Bool x) { m_subLayerProfilePresentFlag[i] = x; }
-  
-  Bool getSubLayerLevelPresentFlag(Int i) const { return m_subLayerLevelPresentFlag[i]; }
-  Void setSubLayerLevelPresentFlag(Int i, Bool x) { m_subLayerLevelPresentFlag[i] = x; }
-
-  ProfileTierLevel* getGeneralPTL()  { return &m_generalPTL; }
-  ProfileTierLevel* getSubLayerPTL(Int i)  { return &m_subLayerPTL[i]; }
-#if H_MV
-  Void inferGeneralValues ( Bool profilePresentFlag  , Int k, TComPTL* refPTL );; 
-  Void inferSubLayerValues( Int maxNumSubLayersMinus1, Int k, TComPTL* refPTL );; 
-#endif
+                          TComPTL();
+  Bool                    getSubLayerProfilePresentFlag(Int i) const   { return m_subLayerProfilePresentFlag[i]; }
+  Void                    setSubLayerProfilePresentFlag(Int i, Bool x) { m_subLayerProfilePresentFlag[i] = x;    }
+
+  Bool                    getSubLayerLevelPresentFlag(Int i) const     { return m_subLayerLevelPresentFlag[i];   }
+  Void                    setSubLayerLevelPresentFlag(Int i, Bool x)   { m_subLayerLevelPresentFlag[i] = x;      }
+
+  ProfileTierLevel*       getGeneralPTL()                              { return &m_generalPTL;                   }
+  const ProfileTierLevel* getGeneralPTL() const                        { return &m_generalPTL;                   }
+  ProfileTierLevel*       getSubLayerPTL(Int i)                        { return &m_subLayerPTL[i];               }
+  const ProfileTierLevel* getSubLayerPTL(Int i) const                  { return &m_subLayerPTL[i];               }
+
+#if NH_MV
+  Void                    inferGeneralValues ( Bool profilePresentFlag  , Int k, TComPTL* refPTL );; 
+  Void                    inferSubLayerValues( Int maxNumSubLayersMinus1, Int k, TComPTL* refPTL );; 
+#endif
+
 };
+
 /// VPS class
 
@@ -318,5 +338,5 @@
   UInt cpbSizeValue      [MAX_CPB_CNT][2];
   UInt ducpbSizeValue    [MAX_CPB_CNT][2];
-  UInt cbrFlag           [MAX_CPB_CNT][2];
+  Bool cbrFlag           [MAX_CPB_CNT][2];
   UInt duBitRateValue    [MAX_CPB_CNT][2];
 };
